package com.yice.webadmin.app.controller;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.BooleanUtil;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ArrayNode;
import com.github.pagehelper.page.PageMethod;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.yice.common.core.annotation.MyRequestBody;
import com.yice.common.core.constant.ErrorCodeEnum;
import com.yice.common.core.object.*;
import com.yice.common.core.util.MyCommonUtil;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.core.util.MyPageUtil;
import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.yice.webadmin.app.constant.DatasetConstant;
import com.yice.webadmin.app.data.DatasetData;
import com.yice.webadmin.app.dto.DatasetVersionDto;
import com.yice.webadmin.app.model.DatasetOutput;
import com.yice.webadmin.app.model.DatasetVersion;
import com.yice.webadmin.app.service.DatasetDataService;
import com.yice.webadmin.app.service.DatasetOutputService;
import com.yice.webadmin.app.service.DatasetVersionService;
import com.yice.webadmin.app.vo.DatasetVersionVo;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.Resource;
import org.springframework.core.io.UrlResource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.*;

/**
 * 数据集版本操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "数据集版本管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/datasetVersion")
public class DatasetVersionController {

    @Autowired
    private DatasetVersionService datasetVersionService;
    @Autowired
    private DatasetDataService datasetDataService;
    @Autowired
    private DatasetOutputService datasetOutputService;
    /**
     * 新增数据集版本数据。
     *
     * @param datasetVersionDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"datasetVersionDto.versionId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody DatasetVersionDto datasetVersionDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetVersionDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetVersion datasetVersion = MyModelUtil.copyTo(datasetVersionDto, DatasetVersion.class);
        datasetVersion = datasetVersionService.saveNew(datasetVersion);
        return ResponseResult.success(datasetVersion.getVersionId());
    }

    /**
     * 更新数据集版本数据。
     *
     * @param datasetVersionDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody DatasetVersionDto datasetVersionDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetVersionDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetVersion datasetVersion = MyModelUtil.copyTo(datasetVersionDto, DatasetVersion.class);
        DatasetVersion originalDatasetVersion = datasetVersionService.getById(datasetVersion.getVersionId());
        if (originalDatasetVersion == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetVersionService.update(datasetVersion, originalDatasetVersion)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 更新数据集版本数据。
     *
     * @param versionId 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @GetMapping("/publish")
    public ResponseResult<Void> publish(@RequestParam("versionId") Long versionId) throws IOException{
        String errorMessage;
        if (null == versionId) {
            errorMessage = "数据验证失败，参数不能为空！";
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetVersion datasetVersion = datasetVersionService.getById(versionId);
        if (datasetVersion == null) {
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        DatasetData datasetDataFilter = new DatasetData();
        datasetDataFilter.setMarkStatus(DatasetConstant.UNMARK);
        datasetDataFilter.setVersionId(versionId);
        Long count = datasetDataService.count(datasetDataFilter);
        if (count > 0) {
            errorMessage = "该数据集不满足发布条件，请确保数据集已完成全部数据标注！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        datasetVersion.setReleaseStatus(DatasetConstant.STATUS_PUBLISHED);
        if (!datasetVersionService.saveDatasetJsonPath(datasetVersion)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除数据集版本数据。
     *
     * @param versionId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long versionId) {
        if (MyCommonUtil.existBlankArgument(versionId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(versionId);
    }

    /**
     * 列出符合过滤条件的数据集版本列表。
     *
     * @param datasetVersionDtoFilter 过滤对象。
     * @param orderParam              排序参数。
     * @param pageParam               分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<DatasetVersionVo>> list(
            @MyRequestBody DatasetVersionDto datasetVersionDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        DatasetVersion datasetVersionFilter = MyModelUtil.copyTo(datasetVersionDtoFilter, DatasetVersion.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, DatasetVersion.class);
        List<DatasetVersion> datasetVersionList =
                datasetVersionService.getDatasetVersionList(datasetVersionFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(datasetVersionList, DatasetVersion.INSTANCE));
    }

    /**
     * 列出符合过滤条件的数据集版本列表。
     *
     * @param datasetVersionDtoFilter 过滤对象。
     * @param orderParam              排序参数。
     * @param pageParam               分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/load")
    public ResponseResult<MyPageData<DatasetVersionVo>> load(
            @MyRequestBody DatasetVersionDto datasetVersionDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        DatasetVersion datasetVersionFilter = MyModelUtil.copyTo(datasetVersionDtoFilter, DatasetVersion.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, DatasetVersion.class);
        //查询我的数据集，如果是管理员可以查询所有，否则只能查看自己
        TokenData tokenData = TokenData.takeFromRequest();
        datasetVersionFilter.setCreateUserId(BooleanUtil.isTrue(tokenData.getIsAdmin()) ? null : tokenData.getUserId());
        List<DatasetVersion> datasetVersionList =
                datasetVersionService.getDatasetVersionList(datasetVersionFilter, orderBy);
        if(CollUtil.isNotEmpty(datasetVersionList)){
            for(DatasetVersion datasetVersion: datasetVersionList){
                datasetVersion.setMarkProgress(calcMarkProgress(datasetVersion.getVersionId(),datasetVersion.getDataVolume()));
            }
        }
        return ResponseResult.success(MyPageUtil.makeResponseData(datasetVersionList, DatasetVersion.INSTANCE));
    }

    /**
     * 计算标记进度
     * @param versionId 版本标识编号
     * @return 获取进度
     */
    private String calcMarkProgress(Long versionId, double allMarkCount) {
        DatasetData datasetDataFilter = new DatasetData();
        datasetDataFilter.setVersionId(versionId);
        datasetDataFilter.setMarkStatus(DatasetConstant.STATUS_PUBLISHED);
        double markCount = datasetDataService.count(datasetDataFilter);
        double percentage = (markCount / allMarkCount) * 100;
        int percent = (int) percentage;
        return percent+ "% (" + (int)markCount + "/" + (int)allMarkCount + ")";
    }

    /**
     * 查看指定数据集版本对象详情。
     *
     * @param versionId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<DatasetVersionVo> view(@RequestParam Long versionId) {
        DatasetVersion datasetVersion = datasetVersionService.getByIdWithRelation(versionId, MyRelationParam.full());
        if (datasetVersion == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        DatasetVersionVo datasetVersionVo = DatasetVersion.INSTANCE.fromModel(datasetVersion);
        return ResponseResult.success(datasetVersionVo);
    }

    /**
     * 查看指定数据集最新版本对象详情。
     *
     * @param datasetId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/lastDatasetVersion")
    public ResponseResult<DatasetVersionVo> lastDatasetVersion(@RequestParam Long datasetId) {
        DatasetVersion datasetVersionFilter = new DatasetVersion();
        datasetVersionFilter.setDatasetId(datasetId);
        List<DatasetVersion> datasetVersions = datasetVersionService.getDatasetVersionList(datasetVersionFilter, "dataset_version");
        if (datasetVersions == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        DatasetVersion datasetVersion = datasetVersions.get(datasetVersions.size() - 1);
        DatasetVersionVo datasetVersionVo = DatasetVersion.INSTANCE.fromModel(datasetVersion);
        return ResponseResult.success(datasetVersionVo);
    }

    private ResponseResult<Void> doDelete(Long versionId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        DatasetVersion originalDatasetVersion = datasetVersionService.getById(versionId);
        if (originalDatasetVersion.getReleaseStatus() == 1) {
            errorMessage = "数据集已发布的状态不允许删除！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (originalDatasetVersion == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetVersionService.remove(originalDatasetVersion.getVersionId())) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }

    @PostMapping(value = "/detail")
    public ResponseResult<MyPageData<String>> detail(@MyRequestBody Long versionId,
                                                     @MyRequestBody MyPageParam pageParam) throws IOException {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        DatasetVersion datasetVersion = this.datasetVersionService.getById(versionId);
        File file = new File(datasetVersion.getFileUrl()); // 指定文件路径
        ObjectMapper objectMapper = new ObjectMapper();
        ArrayNode arrayNode = (ArrayNode) objectMapper.readTree(file); // 读取JSON文件内容并转换为ArrayNode对象
        List<String> dataList = new ArrayList<>();
        for (JsonNode jsonNode : arrayNode) { // 遍历JSON数组并取出每个元素（ObjectNode）中的数据
            dataList.add(jsonNode.toString());
        }
        int total = dataList.size(); // 获取总数据量
        int page = pageParam.getPageNum();
        int limit = pageParam.getPageSize();
        int startIndex = (page - 1) * limit; // 计算起始索引位置
        int endIndex = Math.min(page * limit, total); // 计算结束索引位置（不超出总数据量）
        List<String> pageDataList = dataList.subList(startIndex, endIndex); // 分页处理并取出指定页的数据列表
        return ResponseResult.success(MyPageUtil.makeResponseData(pageDataList, (long) total));
    }

    /**
     * 导入主表数据列表。
     *
     * @param importFile 上传的文件。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.IMPORT)
    @PostMapping("/import")
    public ResponseResult<Void> importFile(
            @RequestParam Long versionId,
            @RequestParam("importFile") MultipartFile importFile) throws IOException {
        String errorMessage;
        if (Objects.isNull(importFile) || importFile.isEmpty()) {
            errorMessage = "数据验证失败，导入文件不能为空！";
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST, errorMessage);
        }
        datasetVersionService.importFile(importFile,versionId);
        return ResponseResult.success();
    }

    @GetMapping("/export")
    public ResponseEntity<Resource> export(@RequestParam Long versionId) throws IOException {
        DatasetVersion datasetVersion = this.datasetVersionService.getById(versionId);
        Path file = Paths.get(datasetVersion.getFileUrl()); // 指定本地JSON文件的路径
        Resource resource = new UrlResource(file.toUri()); // 使用UrlResource从文件路径构建一个Resource对象
        Optional<Resource> optionalResource = Optional.ofNullable(resource);
        if (optionalResource.isPresent() && optionalResource.get().exists()) { // 检查文件是否存在
            HttpHeaders headers = new HttpHeaders(); // 构建HTTP响应头
            headers.add(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=\"" + resource.getFilename() + "\""); // 设置内容类型为附件，并指定文件名
            headers.setContentType(MediaType.TEXT_PLAIN); // 设置内容类型为JSON
            return ResponseEntity.ok() // 返回200 OK状态码
                    .headers(headers) // 设置响应头
                    .contentLength(resource.contentLength()) // 设置响应内容长度（可选）
                    .body(resource); // 将Resource对象作为响应的主体返回
        } else {
            return ResponseEntity.notFound().build(); // 如果文件不存在，返回404 Not Found状态码
        }
    }

    /**
     * 开始导出数据集记录
     * @param versionId 版本标识
     * @param fileType 文件类型
     * @return 返回导出文件链接
     */
    @GetMapping("/startExport")
    public ResponseResult<String> startExport(@RequestParam Long versionId,
                                              @RequestParam String fileType){
        DatasetVersion datasetVersion = this.datasetVersionService.getById(versionId);
        if (datasetVersion == null) {
            String errorMessage = "数据操作失败，查询数据不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST,errorMessage);
        }
        DatasetOutput datasetOutput = datasetOutputService.saveNew(fileType,datasetVersion.getFileUrl(),versionId);
        if (datasetOutput == null) {
            String errorMessage = "导出数据操作失败，请刷新后重试或者联系管理员！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST,errorMessage);
        }
        datasetOutput.setStatus(DatasetConstant.STATUS_FINISHED);
        datasetOutput.setOutputEndTime(new Date());
        datasetOutputService.updateById(datasetOutput);
        return ResponseResult.success(datasetOutput.getDownloadUrl());
    }
}
